﻿// $Id: Exceptions.cs 262 2010-07-28 13:25:26Z cr333 $
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace VideoLib.FlyCapture
{
	[global::System.Serializable]
	public class FlyCaptureException : Exception
	{
		public FlyCaptureException() { }
		public FlyCaptureException(string message) : base(message) { }
		public FlyCaptureException(string message, Exception inner) : base(message, inner) { }
		protected FlyCaptureException(
		  System.Runtime.Serialization.SerializationInfo info,
		  System.Runtime.Serialization.StreamingContext context)
			: base(info, context) { }
	}

	[global::System.Serializable]
	public class CameraNotFoundException : FlyCaptureException
	{
		public CameraNotFoundException() { }
		public CameraNotFoundException(string message) : base(message) { }
		public CameraNotFoundException(string message, Exception inner) : base(message, inner) { }
		protected CameraNotFoundException(
		  System.Runtime.Serialization.SerializationInfo info,
		  System.Runtime.Serialization.StreamingContext context)
			: base(info, context) { }
	}

	[global::System.Serializable]
	public class InvalidVideoModeException : FlyCaptureException
	{
		public InvalidVideoModeException() { }
		public InvalidVideoModeException(VideoMode videoMode) : base(String.Format("VideoMode {0}x{1}-{2} is not supported.", videoMode.Width, videoMode.Height, videoMode.Format)) { }
		public InvalidVideoModeException(string message) : base(message) { }
		public InvalidVideoModeException(string message, Exception inner) : base(message, inner) { }
		protected InvalidVideoModeException(
		  System.Runtime.Serialization.SerializationInfo info,
		  System.Runtime.Serialization.StreamingContext context)
			: base(info, context) { }
	}
}
