﻿// $Id: FlowWarper.frag 459 2010-10-25 11:44:28Z cr333 $
#version 120
#extension GL_EXT_gpu_shader4 : enable

uniform sampler2D image;
uniform sampler2D flow;

uniform int warpDirection;
uniform float magnitude;

void main()
{
	vec4 flows = texture2D(flow, gl_FragCoord.xy / textureSize2D(flow, 0));
	flows *= vec4(1, -1, 1, -1); // invert y

	// compute warped texture coordinates depending on warp direction and magnitude
	vec2 coords = gl_FragCoord.xy;
	switch(warpDirection)
	{
		case 0: coords -= magnitude * flows.xy; break;
		case 1: coords += magnitude * flows.xy; break;
		case 2: coords -= magnitude * flows.zw; break;
		case 3: coords += magnitude * flows.zw; break;
	}

	// simple texture lookup
	gl_FragColor = texture2D(image, coords / textureSize2D(image, 0));
}