﻿// $Id: Enums.cs 544 2011-09-26 17:59:08Z cr333 $
using System;

namespace VideoLib.OpenNI
{
	[Flags]
	public enum Streams
	{
		Image = 1 << 0,
		Depth = 1 << 1,
		IR    = 1 << 2,

		ImageAndDepth = Image | Depth,
		IRAndDepth    = IR    | Depth,
	}

	[Flags]
	public enum Modes
	{
		QVGA  = 1 << 0,
		VGA   = 1 << 1,
		SXGA  = 1 << 2,
		UXGA  = 1 << 3,
		Fps15 = 1 << 16,
		Fps25 = 1 << 17,
		Fps30 = 1 << 18,
		Fps60 = 1 << 19,
	}

	public enum ImageModes
	{
		// all modes from XnSensorImageStream.cpp
		//QVGA_25fps = Modes.QVGA | Modes.Fps25, // "The value is invalid!"
		//QVGA_30fps = Modes.QVGA | Modes.Fps30, // "Device Protocol: Bad Parameter sent!"
		//QVGA_60fps = Modes.QVGA | Modes.Fps60, // "Device Protocol: Bad Parameter sent!"
		//VGA_25fps  = Modes.VGA  | Modes.Fps25, // "The value is invalid!"
		VGA_30fps  = Modes.VGA  | Modes.Fps30,
		SXGA_15fps = Modes.SXGA | Modes.Fps15,
		//SXGA_30fps = Modes.SXGA | Modes.Fps30, // "The value is invalid!"
		//UXGA_30fps = Modes.UXGA | Modes.Fps30, // "The value is invalid!"
	}

	public enum DepthModes
	{
		// all modes from XnSensorDepthStream.cpp
		//QVGA_25fps = Modes.QVGA | Modes.Fps25, // "The value is invalid!"
		//QVGA_30fps = Modes.QVGA | Modes.Fps30, // "Device Protocol: Bad Parameter sent!"
		//QVGA_60fps = Modes.QVGA | Modes.Fps60, // "Device Protocol: Bad Parameter sent!"
		//VGA_25fps  = Modes.VGA  | Modes.Fps25, // "The value is invalid!"
		VGA_30fps  = Modes.VGA  | Modes.Fps30,
	}

	public enum IRModes
	{
		// all modes from XnSensorIRStream.cpp
		//QVGA_25fps = Modes.QVGA | Modes.Fps25, // "The value is invalid!"
		//QVGA_30fps = Modes.QVGA | Modes.Fps30, // "Device Protocol: Bad Parameter sent!"
		//QVGA_60fps = Modes.QVGA | Modes.Fps60, // "Device Protocol: Bad Parameter sent!"
		//VGA_25fps  = Modes.VGA  | Modes.Fps25, // "The value is invalid!"
		VGA_30fps  = Modes.VGA  | Modes.Fps30,
		SXGA_15fps = Modes.SXGA | Modes.Fps15,
	}

	/// <summary>Describes how multiple streams are synchronised, if they are. For a single stream, all options have the same outcome.</summary>
	public enum SyncMode
	{
		/// <summary>Outputs a full set of frames whenever a new frame is received.</summary>
		WaitAny,

		/// <summary>Outputs frames whenever all have been updated.</summary>
		WaitAnd,

		/// <summary>Drop some frames to maintain time-synchronised frames. No duplicate frames.</summary>
		DropFrames,
	}
}