﻿// $Id: IStereoVideoControl.cs 436 2010-10-15 16:26:38Z cr333 $
using System;
using VideoLib.Frames;

namespace VideoLib.Sinks
{
	/// <summary>Implements the basic interface of video controls.</summary>
	public interface IStereoVideoControl
	{
		/// <summary>Accepts a new frame and caption to be drawn onto this control.</summary>
		/// <remarks>This should be save to call from any thread, at any time.</remarks>
		/// <param name="bitmapFrameL">The new left frame.</param>
		/// <param name="bitmapFrameR">The new right frame.</param>
		/// <param name="caption">The new caption.</param>
		void Draw(BitmapFrame bitmapFrameL, BitmapFrame bitmapFrameR, String caption);

		/// <summary>Disposing event, so that VideoDisplay finds out when the UI is shut down.</summary>
		event EventHandler Disposed;
	}
}
